"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _createForOfIteratorHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/createForOfIteratorHelper"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _highlight = _interopRequireDefault(require("highlight.js"));

var React = _interopRequireWildcard(require("react"));

var _reactMarkdown = _interopRequireDefault(require("react-markdown"));

_highlight.default.configure({
  classPrefix: '',
  // don't append class prefix
  tabReplace: '  ' // 2 spaces

});

var PreviewMarkdown = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(PreviewMarkdown, _React$Component);

  var _super = (0, _createSuper2.default)(PreviewMarkdown);

  function PreviewMarkdown(props) {
    var _this;

    (0, _classCallCheck2.default)(this, PreviewMarkdown);
    _this = _super.call(this, props);
    _this.node = void 0;

    _this.allowNode = function (node) {
      if (node.type === 'html' && node.value) {
        if (/<!--([^]+?)-->/.test(node.value)) {
          return false;
        }
      }

      return true;
    };

    _this.state = {
      value: props.value,
      visible: props.visible
    };
    return _this;
  }

  (0, _createClass2.default)(PreviewMarkdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.highlight();
    }
  }, {
    key: "show",
    value: function show() {
      this.setState({
        visible: true
      });
    }
  }, {
    key: "hide",
    value: function hide() {
      this.setState({
        visible: false
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.visible !== this.props.visible) {
        this.setState({
          visible: nextProps.visible
        });
      }
    }
  }, {
    key: "highlight",
    value: function highlight() {
      var code = this.node.getElementsByTagName('code');

      var _iterator = (0, _createForOfIteratorHelper2.default)(code),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var value = _step.value;
          var tag = value.parentNode;

          if (tag && tag.tagName === 'PRE') {
            _highlight.default.highlightBlock(value);
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "updateSource",
    value: function updateSource(value) {
      var _this2 = this;

      this.setState({
        value: value
      }, function () {
        _this2.highlight();
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          visible = _this$props.visible,
          value = _this$props.value,
          previewProps = _this$props.previewProps,
          elementProps = (0, _objectWithoutProperties2.default)(_this$props, ["prefixCls", "visible", "value", "previewProps"]);
      return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        ref: function ref(node) {
          return _this3.node = node;
        },
        className: (0, _classnames2.default)("".concat(prefixCls, "-preview"), (0, _defineProperty2.default)({}, "".concat(prefixCls, "-visible"), this.state.visible))
      }, elementProps), /*#__PURE__*/React.createElement(_reactMarkdown.default, (0, _extends2.default)({
        className: (0, _classnames2.default)("".concat(prefixCls, "-markdown")),
        source: this.state.value,
        escapeHtml: false,
        allowNode: this.allowNode
      }, previewProps)));
    }
  }]);
  return PreviewMarkdown;
}(React.Component);

exports.default = PreviewMarkdown;
PreviewMarkdown.defaultProps = {
  prefixCls: 'md-editor',
  visible: true
};
module.exports = exports.default; 
//# sourceMappingURL=index.js.map